// ilas api functions

void setsegfp(unsigned seg, void far **ptr)
    {
    if(!((unsigned *) *ptr)[1])
        ((unsigned *) *ptr)[1] = seg;
    }

void apicall()
    {
    UINT rax,rbx,rcx,rdx,rds,res,rsi,rdi,curt;
    char *p;
    struct guiele ge;
    ULNG l;
    _asm
        {
        mov rax, ax
        mov rbx, bx
        mov rcx, cx
        mov rdx, dx
        mov rsi, si
        mov rdi, di
        mov ax, ds
        mov rds, ax
        mov ax, es
        mov res, ax
        mov ax, SEG dummy
        mov ds, ax
        sti
        }
    curt = curtask;
    // Do something
    if(rax != 0xABBA && rax != 0x10 && rax != 0x2000) printf("API: 0x%.4X",rax);
    switch(rax)
        {
        // Functions 0-FFF: Standard API
        case 0:         // Function 0: Exit proc.
            task_quit(curt);
            break;
        case 1:         // Function 1: Execute Program (DS:BX=Name DS:DX=Params ; AX=Err)
            rax = task_create(MK_FP(rds,rbx),MK_FP(rds,rdx),curt);
            break;
        case 2:         // Function 2: Convert strtoint (DS:BX = Str ; AX=Num)
            rax = atoi(MK_FP(rds,rbx));
            break;
        case 3:         // Function 3: Convert inttostr (CX=Num DS:DX=Strbuf)
            itoa(rcx,MK_FP(rds,rbx),10);
            break;
        case 4:         // Function 4: Set display mode (BX=X CX=Y DH=BPP DL=Hz ; AX=Err)
            rax = setmode(rbx, rcx, rdx / 256, rdx % 256);
            break;
        case 0x40:      // Function 0x40: Set display mode (BX=X CX=Y DX=BPP ; AX=Err)
            rax = setmode(rbx, rcx, rdx, 0);
            break;
        case 5:         // Function 5: Open file (DS:BX=Nam CX=Cancreate ; AX=Handle/Err)
            *((int *) &rax) = fsopenrel2(MK_FP(rds,rbx),tasks[curt].curdir,curt,rcx);
            break;
        case 6:         // Function 6: Close file (CX=Handle)
            fsclose(rcx);
            break;
        case 7:         // Function 7: Read line from file (CX=Handle DS:BX=Buf DX=Len)
//            printf("readline:%s\n",MK_FP(rds,rbx));
            fsgets(rcx,MK_FP(rds,rbx),rdx);
            break;
        case 8:         // Function 8: Write a line to afile (CX=Handle DS:BX=Str)
            fsputs(rcx,MK_FP(rds,rbx));
            break;
        case 9:         // Function 9: Check for EOF (CX=Handle ; AX=0=EOF)
            rax = fhandles[rcx].len - fhandles[rcx].pos;
            break;
        case 0xA:       // Function A: Insmod (DS:BX=Filename ; AX=Err)
            *((int *) &rax) = insmod(MK_FP(rds, rbx));
            break;
        case 0xB:       // Function B: Convert errorcode to string (CX=Code ; DS:BX=String)
            p = errtostr(((char) rcx));
            rds = FP_SEG(p);
            rbx = FP_OFF(p);
            break;
        case 0xC:       // Function C: Get clock (; DX:AX=Clock)
            rax = clock() * 10;
            rdx = (clock() * 10) >> 16;
            break;
        case 0xD:       // Function D: Sendmessage (BX=Dest CX=Id SI=A DI=B DX=C ; AX=Code)
            if(rbx == 0xFFFF) rbx = curt;
            rax = sendmessage(curt, rbx, rcx, rsi, rdi, rdx);
            break;
        case 0xE:       // Function E: Postmessage (BX=Dest CX=Id SI=A DI=B DX=C ; AX=Code)
            rax = postmessage(curt, rbx, rcx, rsi, rdi, rdx);
            break;
        case 0xF:       // Function F: Peekmessage (; AX=Err CX=Sender DX=Id SI=A DI=B BX=C)
            rax = peekmessage(curt);
            if(rax < 256)
                {
                rcx = tasks[curt].msg[rax].sender;
                rdx = tasks[curt].msg[rax].msgid;
                rsi = tasks[curt].msg[rax].a;
                rdi = tasks[curt].msg[rax].b;
                rbx = tasks[curt].msg[rax].c;
                }
            break;
        case 0x10:      // Function 10: Getmessage (; AX=Err CX=Sender DX=Id SI=A DI=B BX=C)
            rax = getmessage(curt);
            if(rax < 256)
                {
                rcx = tasks[curt].msg[rax].sender;
                rdx = tasks[curt].msg[rax].msgid;
                rsi = tasks[curt].msg[rax].a;
                rdi = tasks[curt].msg[rax].b;
                rbx = tasks[curt].msg[rax].c;
                }
            break;
        case 0x11:      // Function 11: Mount Filesystem (DS:BX=Path DS:DX=Param CX=Driver ; AX=Errcode)
            rax = fsmount(MK_FP(rds,rbx),MK_FP(rds,rdx),rcx);
            break;
        case 0x12:      // Function 12: Read file (CX=Handle, DX=Howmuch, DS:BX=Buf)
            rax = fsread(rcx, rdx, MK_FP(rds,rbx));
            break;
        case 0x13:      // Function 13: Write file (CX=Handle, DX=Howmuch, DS:BX=Buf)
            rax = fswrite(rcx, rdx, MK_FP(rds,rbx));
            break;
        case 0x14:      // Funcion 14: Get File-Pos (CX=Handle; BX:DX=Pos)
            l = fhandles[rcx].pos;
            rbx = l / 65536;
            rdx = l % 65536;
            break;
        case 0x15:      // Function 15: Seek file (CX=Handle; BX:DX=Pos; SI=Origin (0=begin,1=cur,2=end))
            fsseek(rcx, rbx*65536+rdx, rsi);
            break;
        case 0x16:      // Function 16: Get memory-usage by ID (CX=Seek-Id ; AX=Usage in 32-untis, BX=Usage in KB)
            rax = mem_getpara(rcx);     // Seek-IDs: 0=Free Mem 128=Kernel-Mem 127=System-Mem(Nativeos)
            rbx = rax * 32;             // Get App's memory: Pid+1 (pid0: kernel-alloced mem)
            break;
        case 0x17:      // Function 17: Allocate memory (CX=Bytes; ES:0=Addr)
            res = mem_salloc(rcx,curt);
            debhex(res);
            if(res == 0)
                rax = ERR_OUTOFMEMORY;
            else
                rax = 0;
            break;
        case 0x18:      // Function 18: Free memory (ES:0=Addr)
            printf("memfreeapi");
            mem_free(MK_FP(res,0));
            break;
        case 0x19:      // Function 19: Duplicate string (DS:SI=Source ; ES:DI=Copy)
            p = mem_strnew(MK_FP(rds,rsi),curt);
            res = FP_SEG(p);
            rdi = FP_OFF(p);
            break;
        case 0x20:      // Function 20: Get seq. data from file until "-END-"
            getstoend(rcx,MK_FP(rds, rbx));
//            printf("getstoend=%s\n",MK_FP(rds,rbx));
            break;
        case 0x21:      // Function 21: Sleep for some ms
            task_sleep(curt,rbx);
            break;
        case 0x22:      // Function 22: Set a tasks advanced message-status
            tasks[curt].msgstat = rbx;
            break;
        case 0x23:      // Function 23: Set mousepos. on screen
            mouse_move(rbx,rcx);
            break;
        case 0x24:      // Function 24: Disable Mouse
            mouse_begindraw();
            break;
        case 0x25:      // Function 25: Enable Mouse
            mouse_enddraw();
            break;
        case 0x26:      // Function 26: Get PID
            rbx = curt;
            break;
        case 0x27:       // Function 27: Peekmessage2 (DS:SI=MSG-Struct; AX=Err)
            rax = peekmessage(curt);
            if(rax < 256)
                memcpy(MK_FP(rds,rsi),&(tasks[curt].msg[rax].sender),8);
            break;
        case 0x28:      // Function 28: Getmessage2 (DS:SI=MSG-Struct; AX=Err)
            rax = getmessage(curt);
            if(rax < 256)
                memcpy(MK_FP(rds,rsi),&(tasks[curt].msg[rax].sender),8);
            break;
        case 0x29:      // Function 29: Create stringlist at 12-byte field
            strl_initnew(MK_FP(rds,rsi),rcx,curt);
            break;
        case 0x30:      // Function 30: Create stringlist into new buffer
            res = mem_salloc(12,curt);
            strl_initnew(MK_FP(res,0),rcx,curt);
            rdi = 0;
            break;
        case 0x31:      // Function 31: Add an item to a stringlist
            strl_additem(MK_FP(res,rdi),MK_FP(rds,rsi));
            break;
        case 0x32:      // Function 32: Get the number of elements in a stringlist
            rcx = ((strlist *) MK_FP(res,rdi))->count;
            break;
        case 0x33:      // Function 33: Delete an item from a stringlist
            strl_deleteitem(MK_FP(res,rdi),rcx);
            break;
        case 0x34:      // Function 34: Get an item from a stringlist
            res = ((strlist *) MK_FP(res,rdi))->strarr[rcx];
            rdi = 0;
            break;
        case 0x35:      // Function 35: Overwrite an item in a stringlist
            strl_setitem(MK_FP(res,rdi),rcx,MK_FP(rds,rsi));
            break;
        case 0x36:      // Function 36: Clear a stringlist a free all memory except the list itself (12 byte)
            strl_clear(MK_FP(res,rdi));
            break;
        case 0x37:      // Function 37: Clear a stringlist and free its buffer (alloced by 30h)
            strl_free(MK_FP(res,rdi));
            break;
        case 0x38:      // Function 38: OK-Msgbox
            ok_msgbox(MK_FP(rds,rsi));
            break;
        case 0x39:      // Function 39: Read file and copy to a new buffer
            p = MK_FP(rds,rdi);
            fsgets(rcx,p,rdx);
            p = mem_strdup((char *) p,curt);
            res = FP_SEG(p);
            break;
        case 0x41:      // Function 41: Sort a stringlist
            strl_sort(MK_FP(res,rdi),rbx);
            break;
        case 0x42:      // Function 42: Add a long sperated string to a stringlist
            strl_fromsep(MK_FP(res,rdi),MK_FP(rds,rsi),rbx & 0xFF);
            break;
        case 0x43:      // Function 43: Swap two elements in a stringlist
            strl_swap(MK_FP(res,rdi),rbx,rcx);
            printf("swapping strlist items %i <-> %i",rbx,rcx);
            break;
        case 0x44:      // Function 44: Add an item to a string-list at a pos
            strl_additemat(MK_FP(res,rdi),MK_FP(rds,rsi),rcx);
            break;
        case 0x45:      // Function 45: Get next pid
            for(rcx++;rcx<TASKS_MAX;rcx++)
                if(tasks[rcx].used)
                    break;
            if(rcx == TASKS_MAX) rcx = 0xFFFF;
            break;
        case 0x46:      // Function 46: Get task basic infos
            rax = tasks[rcx].used;
            p = tasks[rcx].filename;
            res = FP_SEG(p);
            rsi = FP_OFF(p);
            rbx = tasks[rcx].status;
            rdx = tasks[rcx].msgstat;
            break;
        case 0x47:      // Function 47: Get String length
            rcx = strlen(MK_FP(rds,rsi));
            break;
        case 0x48:      // Function 48: Fill String to a length
            p = MK_FP(rds,rsi);
            rdx = strlen(p);
            printf("Setstring '%s' to %i",p,rcx);
            while(rdx < rcx)
                p[rdx++] = rbx;
            p[rdx] = 0;
            printf("Result = '%s'",p);
            break;
        case 0x49:      // Function 49: Copy string
            strcpy(MK_FP(res,rdi),MK_FP(rds,rsi));
            break;
        case 0x50:      // Function 50: Concatenerate string
            strcat(MK_FP(res,rdi),MK_FP(rds,rsi));
            break;
        case 0x51:      // Function 51: Convert paragraphs to string
            p = MK_FP(rds,rdi);
            sprintf(p,"%.6lu",(long) (((long) rcx)*32));
            if(rcx)
                while(*p == '0')
                    *(p++) = ' ';
            break;
        case 0x52:         // Function 52: Kill process
            printf("Kill: %i",rdx);
            task_quit(rdx);
            break;
    // Functions 1000-10FF: Graphic functions
        case 0x1000:    // Function 1000: Setpixel
            if(rsi) wm_setpixel(rsi,rbx,rcx,rdi); else
            setpixel(rbx,rcx,rdi);
            break;
        case 0x1001:    // Function 1001: HLine
            if(rsi) wm_hline(rsi,rbx,rcx,rdx,rdi); else
            hline(rbx,rcx,rdx,rdi);
            break;
        case 0x1002:    // Function 1002: VLine
            if(rsi) wm_vline(rsi,rbx,rcx,rdx,rdi); else
            vline(rbx,rcx,rdx,rdi);
            break;
        case 0x1003:    // Function 1003: Draw Sprite
            if(rsi) wm_drawsprite(rsi,rcx,rdx,MK_FP(rds,rbx)); else
            drawsprite(rcx,rdx,MK_FP(rds,rbx));
            break;
        case 0x1005:    // Function 1005: Load simple font
            rax = loadfont(MK_FP(rds, rbx));
            break;
        case 0x1006:    // Function 1006: Textout (CX/DX=Pos, DS:SI=Datastruct (UINTS 0=FG 1=BG 2=FNTID), DS:DI=Text)
            p = MK_FP(rds, rsi);
            if(rbx) rax = wm_outtext(rbx,rcx,rdx,((UINT *)p)[0],((UINT *)p)[1],((UINT *)p)[2],MK_FP(rds,rdi)); else
            rax = outtext(rcx,rdx,((UINT *)p)[0],((UINT *)p)[1],((UINT *)p)[2],MK_FP(rds,rdi));
            break;
        case 0x1007:    // Function 1007: Rect
            if(res) wm_rect(res,rbx,rcx,rdx,rsi,rdi); else
            rect(rbx,rcx,rdx,rsi,rdi);
            break;
        case 0x1008:    // Function 1008: RectF
            if(res) wm_rectf(res,rbx,rcx,rdx,rsi,rdi); else
            rectf(rbx,rcx,rdx,rsi,rdi);
            break;
        case 0x1009:    // Function 1009: SizeOfDDB
            l = sizeofddb(rbx,rcx);
            rax = l;
            rdx = l >> 16;
            break;
        case 0x100A:    // Function 100A: dibcreate
            rax = dib_create(curt,rbx,rcx,rdx,rsi);
            break;
        case 0x100B:    // Function 100B: dib_load
            rax = dib_load(curt,MK_FP(rds,rsi),rbx);
            break;
        case 0x100C:    // Function 100C: dib_destroy
            rax = dib_destroy(rbx);
            break;
        case 0x100D:    // Function 100D: dib2ddb
            p = MK_FP(rds,rsi);
            rax = dib_to_ddb(rbx,MK_FP(res,rdi),((prect) p)->left,((prect) p)->top,((prect) p)->right,((prect) p)->bottom);
            break;
        case 0x100E:    // Function 100E: drawddb
            if(rdi) wm_drawddb(rdi,rbx,rcx,MK_FP(rds,rsi)); else
            drawddb(rbx,rcx,MK_FP(rds,rsi));
            break;
        case 0x100F:    // Function 100F: dib_getgeometry
            rax = dib_geometry(rsi,&rbx,&rcx);
            break;
        case 0x1010:    // Function 1010: ddb_loadfromfile
            p = ddb_loadfromfile(curt,MK_FP(rds,rsi),rbx);
            res = FP_SEG(p);
            break;
        case 0x1011:    // Function 1011: clrscr/fillclient
            if(rsi) wm_fillclient(rsi,rbx); else
            clearscr(rbx);
            break;
        case 0x1012:    // Function 1012: create window
            p = MK_FP(rds,rsi);
            setsegfp(rds,(void **) &(((struct createwin *) p)->wprg));
            setsegfp(rds,(void **) &(((struct createwin *) p)->title));
            setsegfp(rds,(void **) &(((struct createwin *) p)->icon));

            rax = wm_create((struct createwin *) p);
            break;
        case 0x1013:    // Function 1013: delete window
            wm_delete(rbx);
            break;
        case 0x1014:    // Function 1014: bring window to fg
            wm_fgwindow(rbx);
            break;
        case 0x1016:    // Fcuntion 1016: create and paint window
            p = MK_FP(rds,rsi);
            setsegfp(rds,(void **) &(((struct createwin *) p)->wprg));
            setsegfp(rds,(void **) &(((struct createwin *) p)->title));
            setsegfp(rds,(void **) &(((struct createwin *) p)->icon));

            rax = wm_create((struct createwin *) p);
            if(rax < 0x8000) wm_fgwindow(rax);
            break;
        case 0x1017:    // Function 1017: select windowmanager
            wm_select(MK_FP(rds,rsi));
            break;
        case 0x1018:    // Function 1016: Draw a button
            wm_drawbutton(rdx,rbx,rcx,rsi,rdi,res);
            break;
        case 0x1019:    // Function 1017: Draw a button down
            wm_drawbuttondown(rdx,rbx,rcx,rsi,rdi,res);
            break;
        case 0x101A:    // Function 1018: Draw an option button
            wm_drawoptbtn(rdx,rbx,rcx,rsi,rdi);
            break;
        case 0x101B:    // Function 1019: Draw a checkbox
            wm_drawcheckbox(rdx,rbx,rcx,rsi,rdi);
            break;
        case 0x101C:    // Function 101C: Draw a dib
            wm_dib_draw_dib(rdx,rbx,rcx,rsi);
            break;
        case 0x101D:    // Function 101D: Get windowsize
            rbx = curx;
            rcx = cury-tbheight-hbheight;       // TODO: Add wm compatibility
            break;
    // Functions 2000+: GUI + xtended wnds
        case 0x2000:    // Function 2000: Dispatch a previously received message
            dispatchmessage(rcx,curt,rdx,rsi,rdi,rbx);
            break;
        case 0x2001:    // Function 2001: Repaint a window
            gui_repaintwnd(rdx);
            break;
        case 0x2002:    // Function 2002: Create a Simplebutton
            ge.typ = CT_SIMPLEBUTTON;
            ge.wnd = rdx;
            ge.x1 = rbx;
            ge.y1 = rcx;
            ge.text = MK_FP(rds,rsi);
            ge.fntid = rdi;
            ge.fgcol = 0;
            ge.subitem = NULL;
            ge.ownedby = NULL;
            ge.visible = 1;
            rax = gui_create(&ge);
            break;
        case 0x2003:    // Function 2003: Create a checkbox
            ge.typ = CT_CHECKBOX;
            ge.wnd = rdx;
            ge.x1 = rbx;
            ge.y1 = rcx;
            ge.checked = rsi;
            ge.subitem = NULL;
            ge.ownedby = NULL;
            ge.visible = 1;
            rax = gui_create(&ge);
            break;
        case 0x2004:    // Function 2004: Create a label
            ge.typ = CT_LABEL;
            ge.wnd = rdx;
            ge.x1 = rbx;
            ge.y1 = rcx;
            ge.text = MK_FP(rds,rsi);
            ge.fntid = rdi;
            ge.fgcol = res;
            ge.bgcol = 0xFFF;
            ge.subitem = NULL;
            ge.ownedby = NULL;
            ge.visible = 1;
            rax = gui_create(&ge);
            break;
        case 0x2005:    // Function 2005: Create a rect
            ge.typ = CT_RECT;
            ge.wnd = rdx;
            ge.x1 = rbx;
            ge.y1 = rcx;
            ge.x2 = rsi;
            ge.y2 = rdi;
            ge.fgcol = res;
            ge.subitem = NULL;
            ge.ownedby = NULL;
            ge.visible = 1;
            rax = gui_create(&ge);
            break;
        case 0x2006:    // Function 2006: Create a frect
            ge.typ = CT_RECTF;
            ge.wnd = rdx;
            ge.x1 = rbx;
            ge.y1 = rcx;
            ge.x2 = rsi;
            ge.y2 = rdi;
            ge.fgcol = res;
            ge.subitem = NULL;
            ge.ownedby = NULL;
            ge.visible = 1;
            rax = gui_create(&ge);
            break;
        case 0x2007:    // Function 2007: Create a sprite
        case 0x2014:    // Function 2014: Create sprite with label
            ge.typ = CT_SPRITE;
            ge.wnd = rdx;
            ge.x1 = rbx;
            ge.y1 = rcx;
            ge.data = MK_FP(rds,rsi);
            ge.subitem = NULL;
            ge.ownedby = NULL;
            ge.visible = 1;
            if(rax == 0x2007)
                rax = gui_create(&ge);
            else
                {
                rax = gui_create(&ge);
                p = (char *) gui_findobj(rax);
                ge.typ = CT_LABEL;
                ge.y1 = ((struct guiele *) p)->y2+2;
                ge.text = MK_FP(res,rdi);
                ge.fntid = 0;
                ge.fgcol = 0;
                ge.bgcol = 0xFFF;
                ge.x1 = (((struct guiele *) p)->x1+((struct guiele *) p)->x2)/2 - textwidth(ge.fntid,ge.text)/2;
//                printf("Creating lbl/sprite. Pic=%s, Label=%s\n",MK_FP(rds,rsi),MK_FP(res,rdi));
                rbx = gui_create(&ge);
                }
            break;
        case 0x2008:    // Function 2008: Create a scrollbar
            ge.typ = CT_SCROLLBAR;
            ge.wnd = rdx;
            ge.x1 = rbx;
            ge.y1 = rcx;
            ge.x2 = rsi;
            ge.y2 = rdi;
            ge.checked = res;
            ge.fntid = 0;
            ge.fgcol = 0;
            ge.bgcol = 10;
            ge.ownedby = NULL;
            ge.subitem = NULL;
            ge.visible = 1;
            rax = gui_create(&ge);
            break;
        case 0x2009:    // Function 2009: Create a listbox
            ge.typ = CT_LISTBOX;
            ge.wnd = rdx;
            ge.x1 = rbx;
            ge.y1 = rcx;
            ge.x2 = rsi;
            ge.y2 = rdi;
            ge.fntid = 0;
            ge.fgcol = 0;
            ge.bgcol = 15;
            ge.data = MK_FP(res,0);
            ge.grp = -1;
            ge.subitem = NULL;
            ge.ownedby = NULL;
            ge.visible = 1;
            rax = gui_create(&ge);
            break;
        case 0x2010:    // Function 2010: Get Tag
            p = (void *) gui_findobj(rcx);
            if(p)
                {
                rax = 0;
                rbx = ((struct guiele *) p)->tag1;
                rdx = ((struct guiele *) p)->tag2;
//                printf("get tag: ele %i - BX=%i,DX=%i\n",rcx,rbx,rdx);
                }
            else rax = ERR_INVALIDGUIELE;
            break;
        case 0x2011:    // Function 2011: Set Tag
            p = (void *) gui_findobj(rcx);
            if(p)
                {
                rax = 0;
                ((struct guiele *) p)->tag1 = rbx;
                ((struct guiele *) p)->tag2 = rdx;
//                printf("set tag: ele %i - BX=%i,DX=%i\n",rcx,rbx,rdx);
                }
            else rax = ERR_INVALIDGUIELE;
            break;
        case 0x2012:    // Function 2012: Create an optionbutton
            ge.typ = CT_RADIO;
            ge.wnd = rdx;
            ge.x1 = rbx;
            ge.y1 = rcx;
            ge.checked = rsi;
            ge.grp = rdi;
            ge.subitem = NULL;
            ge.ownedby = NULL;
            ge.visible = 1;
            rax = gui_create(&ge);
            break;
        case 0x2013:    // Function 2013: Create a combobox
            ge.typ = CT_COMBOBOX;
            ge.wnd = rdx;
            ge.x1 = rbx;
            ge.y1 = rcx;
            ge.x2 = rsi;
            ge.fntid = 0;
            ge.fgcol = 0;
            ge.bgcol = 15;
            ge.data = MK_FP(res,0);
            ge.text = NULL;
            ge.grp = -1;
            ge.subitem = NULL;
            ge.ownedby = NULL;
            ge.visible = 1;
            rax = gui_create(&ge);
            break;
        case 0x2015:    // Function 2015: Create a ddb-image
            ge.typ = CT_DDB;
            ge.wnd = rdx;
            ge.x1 = rbx;
            ge.y1 = rcx;
            ge.data = MK_FP(res,0);
            ge.subitem = NULL;
            ge.ownedby = NULL;
            ge.visible = 1;
            rax = gui_create(&ge);
            break;
        case 0x2016:    // Function 2016: Create a dib-image
            ge.typ = CT_DIB;
            ge.wnd = rdx;
            ge.x1 = rbx;
            ge.y1 = rcx;
            ge.fntid = rsi;
            ge.subitem = NULL;
            ge.ownedby = NULL;
            ge.visible = 1;
            rax = gui_create(&ge);
            break;
        case 0x2017:    // Function 2017: Repaint a single gui-element
            p = (void *) gui_findobj(rdx);
            gui_repaintele((void *) p,rdx);     
            break;
        case 0x2018:    // Function 2018: Set Text
            p = (void *) gui_findobj(rdx);
            mem_free(((struct guiele *) p)->text);
            ((struct guiele *) p)->text = mem_strnew(MK_FP(rds,rsi),getwndowner(((struct guiele *) p)->wnd));
            break;
        case 0x2019:    // Function 2019: Get Itemindex
            p = (void *) gui_findobj(rdx);
            rdx = ((struct guiele *) p)->grp;
            printf("idx=%i",rdx);
            break;
        case 0x2020:    // Function 2020: Paint screen
            wm_paint(0xff,fgwin);
            break;
    // Functions 3000+: Commandline and console functions
        case 0x3000:    // Function 3000: Set/Get handles
            if(rcx == 0xFFFF) rcx = curt;
            if(rbx & 1) tasks[rcx].Hstdin = rsi; else rsi = tasks[rcx].Hstdin;
            if(rbx & 2) tasks[rcx].Hstdout = rdi; else rdi = tasks[rcx].Hstdout;
            if(rbx & 4) tasks[rcx].Hstderr = rdx; else rdx = tasks[rcx].Hstderr;
            break;
        case 0x3001:    // Function 3001: Write line & lf to stdout
            fsputs(tasks[rcx].Hstdout,MK_FP(rds,rsi));
            break;
        case 0x3002:    // Function 3002: Write line & lf to stderr
            fsputs(tasks[rcx].Hstderr,MK_FP(rds,rsi));
            break;
        case 0x3003:    // Function 3003: Read string+enter from stdin
            fsgets(tasks[rcx].Hstdin,MK_FP(rds,rdi),rcx);
            break;
        case 0x3004:    // Function 3004: Read a single char from stdin
            rax = fsgetc(tasks[rcx].Hstdin);
            break;
    // Functions A000+: Internal and driver use ONLY
        case 0xA000:    // Function A000: Allocate kernel-memory
            res = mem_salloc(rax,0);
            rbx = 0;
            break;
        case 0xA001:    // Function A001: Free Kernel-memory
            mem_free(MK_FP(res,0));
            break;
        case 0xA002:    // Function A002: Open file for kernel/driver
            *((UCHR *) &rax) = fsopen2(MK_FP(rds,rbx),0,rcx);
            break;
        case 0xA003:    // Function A003: Close kernel/driver file (CX=Handle)
            fsclose(rcx);
            break;
        case 0xABBA:    // Function ABBA: Switch task
                        // INTERNAL! DONT CALL IN YOUR APP OR DRIVER!
                        // IT WILL CRASH YOUR SYSTEM
            p = getnewstack(MK_FP(rcx, rbx));
            rcx = FP_SEG(p);
            rbx = FP_OFF(p);
            break;
        case 0xABBB:    // Function ABBB: Look for a mousedriver
            mouse_look();
            break;
        case 0xABBC:    // Function ABBC: Look for keyboards
            keyb_look();
            break;
        case 0xABBD:    // Function ABBD: Send debug-string (DS:BX)
            fsputs(debfile,MK_FP(rds,rbx));
            break;
        case 0xABBE:    // Function ABBE: Send debug-int (cx)
            debint(rcx);
            break;
        case 0xABBF:    // Function ABBF: Send debug-hex (cx)
            debhex(rcx);
            break;
        case 0xABC0:    // Function ABC0: Set Foreground window
//                    (it does NOT select a wnd or anything - just used by the
//                     driver to signal a window-change!)
            fgwin = rbx;
            break;
        case 0xABC1:    // Function ABC1: Beep
            beeper();
            break;
        case 0xABC2:    // Function ABC2: Send kernel message (BX=Dest CX=Id SI=A DI=B DX=C ; AX=Code)
            if(rbx == 0xFFFF) rbx = 0;
            rax = sendmessage(0, rbx, rcx, rsi, rdi, rdx);
            break;

        default:
            printf("Invalid function call: %u (BX=%u,CX=%u,DX=%u,SI=%u,DI=%u,DS=%u,ES=%u)\n",rax,rbx,rcx,rdx,rsi,rdi,rds,res);
            rdx = rcx = rbx = rax = 0xFFFF;
        }

    _asm
        {
        mov ax, rds
        mov ds, ax
        mov ax, res
        mov es, ax
        mov si, rsi
        mov di, rdi
        mov dx, rdx
        mov cx, rcx
        mov bx, rbx
        mov ax, rax
        mov sp, bp
        pop bp
        iret
        }
    }
