// Display-functions

#define FONT_MAX 64

char *allthechars = "FrgajnDre,sc:;her";

UCHR curdrv,curbpp,curhz;
UINT curx, cury, curddb;
void *curdrvcall;
UCHR *fonttab[FONT_MAX];
unsigned nextdibhandle=1;

#define DDB_0815 0
#define DDB_8BIT_PLANAR 1
#define DDB_24BIT_RGB 2
#define DDB_24BIT_DWORD_RGB 3
#define DDB_15BIT_PLANAR 4
#define DDB_CUSTOM 0x10
#define DDB_CUSTOM_PLANAR 0x11
#define DDB_CUSTOM_INTERLEAVED 0x12

#define BPP4 4
#define BPP4_CUSTOMPALETTE 5
#define BPP8 8
#define BPP8_CUSTOMPALETTE 9
#define BPP24 24
#define BPP32 32

#define NEWDIB_LOAD_LOCALMEM 0
#define NEWDIB_LOAD_SWAP 1
#define NEWDIB_TRY_LOCALMEM 2
#define NEWDIB_TRY_SWAP 3

typedef struct
    {
    unsigned left,top,right,bottom;
    } trect;

#define prect trect *

unsigned long sizeofddb(unsigned x, unsigned y);

struct genericdib
    {
    unsigned handle;
    unsigned char owner;
    unsigned width;
    unsigned height;
    unsigned bpp;
    void far *dibdata;      // Pointer (fhnd=0)
    unsigned fhnd;          // Filehandle (0=local basememory) (<>0=file,dibdata=0)
    unsigned long size;
    struct genericdib *next;
    } *dibs=NULL;

void setpixel(UINT x,UINT y,UINT col)
    {
    if(x >= curx || y >= cury) return;
    mouse_drawbegin();
    _asm
        {
        push ds
        mov ax, 0601h
        mov bx, x
        mov cx, y
        mov si, col
        call curdrvcall
        pop ds
        }
    mouse_drawend();
    }

unsigned getpixel(UINT x, UINT y)
    {
    mouse_drawbegin();
    _asm
        {
        push ds
        mov ax, 0602h
        mov bx, x
        mov cx, y
        call curdrvcall
        pop ds
        mov ax, si
        }
    mouse_drawend();
    }

void set0815(UINT x, UINT y, UINT *data)
    {
    UINT i=FP_SEG(data), j=FP_OFF(data), k, *p;
    mouse_drawbegin();
    _asm
        {
        push ds
        mov ax, i
        mov es, ax
        mov ax, 0608h
        mov bx, x
        mov cx, y
        mov si, j
        call curdrvcall
        pop ds
        cmp ax, 0xDEAD
        jnz setpixmap_ok
        }
    p = &(data[2]);
    for(j=0;j<data[1];j++)
        for(i=0;i<data[0];i++)
            {
            if((k = *(p++)) != 0xF00)
              _asm
                {
                mov ax, 0601h
                mov bx, i
                add bx, x
;                cmp bx, curx
;                jnb outres
                mov cx, j
                add cx, y
;                cmp cx, cury
;                jnb outres
                mov si, k
                push ds
                call curdrvcall
                pop ds
                }
//            outres:;
            }
    setpixmap_ok:;
    mouse_drawend();
    }

void get0815(UINT x1, UINT y1, UINT x2, UINT y2, UINT *data)
    {
    UINT i=FP_SEG(data), j=FP_OFF(data), k, *p;
    mouse_drawbegin();
    data[0] = x2-x1+1;
    data[1] = y2-y1+1;
    _asm
        {
        push ds
        mov ax, i
        mov es, ax
        mov ax, 0609h
        mov bx, x1
        mov cx, y1
        mov dx, x2
        mov si, y2
        mov di, j
        call curdrvcall
        pop ds
        cmp ax, 0xDEAD
        jnz getpixmap_ok
        }
    p = &(data[2]);
    for(j=0;j<data[1];j++)
        for(i=0;i<data[0];i++)
            {
            _asm
                {
                mov ax, 0602h
                mov bx, i
                add bx, x1
                mov cx, j
                add cx, y1
                push ds
                call curdrvcall
                pop ds
                mov k, si
                }
            *(p++) = k;
            }
    getpixmap_ok:;
    mouse_drawend();
    }

void hline(UINT x1,UINT y,UINT x2,UINT col)
    {
    if(y >= cury || x1 > curx) return;
    if(x2 >= curx) x2 = curx - 1;
    mouse_drawbegin();
    _asm
        {
        push ds
        mov ax, 0603h
        mov bx, x1
        mov cx, y
        mov dx, x2
        mov si, col
        call curdrvcall
        pop ds
        cmp ax, 0xDEAD
       jnz hline_ok

        mov bx, x1

    hline_loop:
        mov cx, y
        mov ax, 0601h
        mov si, col
        push bx
        push ds
        call curdrvcall
        pop ds
        pop bx
        cmp bx, x2
       jz hline_ok
        inc bx
       jmp hline_loop

    hline_ok:
        }
    mouse_drawend();
    }

void dline(UINT x,UINT y,UINT l,int d,UINT col)
    {
    if(y >= cury || x > curx) return;
    mouse_drawbegin();
    _asm
        {
        push ds
        mov ax, 060Ah
        mov cx, x
        mov bx, y
        mov dx, l
        mov di, d
        mov si, col
        call curdrvcall
        pop ds
        cmp ax, 0xDEAD
        jnz dline_ok
        }
    if(d) d = 1; else d = -1;
    l++;
    while(l--)
        setpixel(x,y++,col),x+=d;
    dline_ok:
    mouse_drawend();
    }

void vline(UINT y1,UINT x,UINT y2,UINT col)
    {
    if(x >= curx || y1 > cury) return;
    if(y2 >= cury) y2 = cury - 1;
    mouse_drawbegin();
    _asm
        {
        mov ax, 0604h
        mov bx, y1
        mov cx, x
        mov dx, y2
        mov si, col
        push ds
        call curdrvcall
        pop ds
        cmp ax, 0xDEAD
       jnz vline_ok

        mov cx, y1
    vline_loop:
        mov bx, x
        mov ax, 0601h
        mov si, col
        push cx
        push ds
        call curdrvcall
        pop ds
        pop cx
        cmp cx, y2
       jz vline_ok
        inc cx
       jmp vline_loop

    vline_ok:
        }
    mouse_drawend();
    }

void rect(UINT x1, UINT y1, UINT x2, UINT y2, UINT col)
    {
    mouse_drawbegin();
    _asm
        {
        push ds
        mov ax, 0605h
        mov bx, x1
        mov cx, y1
        mov dx, x2
        mov di, y2
        mov si, col
        call curdrvcall
        pop ds
        cmp ax, 0xDEAD
        jnz rect_ok
        }
    hline(x1,y1,x2,col);
    hline(x1,y2,x2,col);
    vline(y1,x1,y2,col);
    vline(y1,x2,y2,col);
    rect_ok:;
    mouse_drawend();
    }

void rectf(UINT x1, UINT y1, UINT x2, UINT y2, UINT col)
    {
    int i;
    mouse_drawbegin();
    _asm
        {
        push ds
        mov ax, 0606h
        mov bx, x1
        mov cx, y1
        mov dx, x2
        mov di, y2
        mov si, col
        call curdrvcall
        pop ds
        cmp ax, 0xDEAD
        jnz rectf_ok
        }
    if(x2-x1 >= y2-y1)
        for(i=y1;i<=y2;i++)
            hline(x1,i,x2,col);
    else
        for(i=x1;i<=x2;i++)
            vline(y1,i,y2,col);
    rectf_ok:;
    mouse_drawend();
    }

void clearscr(UINT fillcol)
    {
    mouse_drawbegin();
    _asm
        {
        mov ax, 0610h
        mov bx, fillcol
        push ds
        call curdrvcall
        pop ds
        cmp ax, 0xDEAD
        jnz clrscrok
        }
    rectf(0,0,curx-1,cury-1,fillcol);
    clrscrok:;
    mouse_drawend();
    }

setmode(UINT x, UINT y, UCHR bpp, UCHR hz)
    {
    int i,j;
    void *xx;

    for(i=127;i>=0;i--)
        if(drvlist[i].used)
            if(drvlist[i].dtyp == DTYP_DISPLAY)
                {
                xx = drvlist[i].drvcall;
                _asm
                    {
                    push ds
                    mov ax, 0600h       // Switch resolution
                    mov bx, x
                    mov cx, y
                    mov dh, bpp
                    mov dl, hz
                    call xx
                    pop ds
                    cmp ax, 0DEADh
                    jz noressw
                    mov j, ax
                    }
                curdrv = i;
                curx = x;
                cury = y;
                curbpp = bpp;
                curhz = hz;
                curddb = j;
                curdrvcall = (void *) drvlist[i].drvcall;

                if(mpbuf) { mem_free(mpbuf); printf("memfree_setmodempbuf"); }
                mpbuf = mem_malloc(sizeofddb(xsize,ysize),0);
                mpbufvalid = 0;

                return 0;
                noressw:;
                }
    return ERR_INVALIDRESOLUTION;
    }

void drawsprite(UINT x, UINT y, char *sprite)
    {
    UINT xx=x;
    UINT i=FP_SEG(sprite), j=FP_OFF(sprite);
    mouse_drawbegin();
    _asm
        {
        push ds
        mov ax, i
        mov es, ax
        mov ax, 0607h
        mov bx, x
        mov cx, y
        mov si, j
        call curdrvcall
        pop ds
        cmp ax, 0xDEAD
        jnz sprite_ok
        }
    while(*sprite != 0)
        {
        if(*sprite == 0xA)
            x = xx, y++;
        else if(*sprite == 0xD)
            x = xx;
        else if(*sprite == 8)
            x--;
        else if(*sprite == ' ')
            x++;
        else if(*sprite == '*')
            _asm
                {
                mov ax, 0602h
                mov bx, x
                inc bx
                mov x, bx
;                cmp bx, curx
;                jnb outressp
                mov cx, y
                mov si, i
                push ds
                call curdrvcall
                pop ds

                neg si

                mov ax, 0601h
                mov bx, x
                mov cx, y
                mov si, i
                push ds
                call curdrvcall
                pop ds
                }

        else
            {
            i = (((UCHR) *sprite) | 32) - 97;
            _asm
                {
                mov ax, 0601h
                mov bx, x
                inc bx
                mov x, bx
;                cmp bx, curx
;                jnb outressp
                mov cx, y
                mov si, i
                push ds
                call curdrvcall
                pop ds
                }
            }
//        outressp:;
        sprite++;
        }
    sprite_ok:;
    mouse_drawend();
    }

sprite_size(char *sprite, UINT *x, UINT *y)
    {
    UINT curx=0,curlinmd=0;
    *x = 0; *y = 0; sprite--;
    while(*(++sprite))
        switch(*sprite)
            {
            case 8: curx--; break;
            case 13: curx=0;
            case 10: if(curlinmd > *x) *x = curlinmd;
                     curlinmd=0;curx=0;(*y)++;break;
            default: if(++curx > curlinmd) curlinmd = curx;
            }
    if(curlinmd > *x) *x = curlinmd;
    if(sprite[-1] != 10) (*y)++;
    }

int loadfont(char *filename)
    {
    int i,j;
    for(i=0;i<FONT_MAX;i++)
        if(fonttab[i] == NULL)
            goto loadthere;
    return ERR_FONTTABFULL;
    loadthere:
    if((j = fsopen(filename,0)) < 0)
        return j;
    if((fonttab[i] = (void *) mem_malloc(fhandles[j].len,0)) == NULL)
        {
        fsclose(j);
        return ERR_OUTOFMEMORY;
        }
    fsread(j,fhandles[j].len,(void *) fonttab[i]);
    fsclose(j);
    return i;
    }

    // 0=OK, 1=Error
#define textout outtext
outtext(int x, int y, UINT fgc, UINT bgc, int fntid, char far *thetext)
    {
    UINT pxhigh=8;
    UCHR *suchptr;
    UCHR *text=(UCHR far *) thetext;
    UCHR tline[8];
    UINT i,j;
    UCHR *sombuf,*p;
    int xx;
//    printf("textout(x=%i,y=%i,fgc=%i,bgc=%i,fnt=%i,text='%s'",x,y,fgc,bgc,fntid,thetext);
    if(fonttab[fntid] == NULL) return ERR_INVALIDFONTID;
    mouse_begindraw();
    if(fonttab[fntid][0] == 1)  // Font Version 1
        {
//        if(bgc != 0xFFF) rectf(x,y,x+strlen(thetext)*8,y+8,bgc);
        suchptr = NULL;
        xx = x;
        while(*text != 0)
            {
            if(*text == 10)
                x = xx, y += pxhigh, text++;
            else
                {
                if(bgc != 0xFFF) rectf(x,y,x+8,y+8,bgc);
                if(suchptr == NULL || *suchptr > *text)
                    suchptr = fonttab[fntid] + 1;   // Begin seeking
                while((*suchptr != *text) && (*suchptr != 0))
                    suchptr += suchptr[1]*4+2;
                if(*suchptr != 0 && *suchptr != 32)   // Found, not space?
                    {   // Lets draw it
                    for(i=0,p=suchptr+2;i<suchptr[1];i++,p+=4)
                        if(p[3] == 0)
                            setpixel(p[1]+x,p[2]+y,fgc);
                        else
                            switch(*p)
                                {
                                case 1: hline(p[1]+x,p[2]+y,p[3]+x+p[1],fgc); break;
                                case 2: vline(p[2]+y,p[1]+x,p[3]+y+p[2],fgc); break;
                                case 3: dline(p[1]+x,p[2]+y,p[3],0,fgc); break;
                                case 4: dline(p[1]+x,p[2]+y,p[3],1,fgc); break;
                                }
                    }
                else
                    suchptr = NULL;
                text++;
                x += 8;
                }
            }
        }
    else if(fonttab[fntid][0] == 0)  // Font Version 0
        {
        xx=x-8;
        pxhigh = fonttab[fntid][1];
        while(*text != 0)
            {
            if(*text == 10)
                x = xx, y += pxhigh;
            else
                {
                suchptr = fonttab[fntid] + 2;   // Begin seeking
                while((*suchptr != *text) && (*suchptr != 0))
                    suchptr += pxhigh + 1;
                if(*suchptr != 0)   // Found?
                    {   // Lets draw it
                    for(i=0;i<pxhigh;i++)
                        {
                        suchptr++;
                        tline[0] = *suchptr & 128;
                        tline[1] = *suchptr & 64;
                        tline[2] = *suchptr & 32;
                        tline[3] = *suchptr & 16;
                        tline[4] = *suchptr & 8;
                        tline[5] = *suchptr & 4;
                        tline[6] = *suchptr & 2;
                        tline[7] = *suchptr & 1;
                            // Decoded! Now draw it to x+j,y+i
                            for(j=0;j<8;j++)
                                if(tline[j])
                                    {
                                    if(fgc != 0xFFF)
                                        setpixel((x+j),(y+i),fgc);
                                    }
                                else
                                    if(bgc != 0xFFF)
                                        setpixel((x+j),(y+i),bgc);
                        }
                    }
                }
            text++;
            x += 8;
            }                
        }
    else
        {
        mouse_enddraw();
        return ERR_FONTVERNOTSUP;
        }
    mouse_enddraw();
    return 0;
    }

int textwidth(int fntid, char *txt)
    {
    if(fonttab[fntid][0] <= 1)  // Font Version 0
        return 8 * strlen(txt);
    }

int textheight(int fntid, char *txt)
    {
    if(fonttab[fntid][0] == 0)  // Font Version 0
        return fonttab[fntid][1];
    if(fonttab[fntid][0] == 1)
        return 8;
    }
    
// DDB (Device-Dependent-Bitmap) and
// DIB (Device-Independent-Bitmap) functions

#define ddbwidth(ddb) (((unsigned *) ddb)[0])
#define ddbheight(ddb) (((unsigned *) ddb)[1])
#define ddbsize(ddb) sizeofddb(ddbwidth((ddb)),ddbheight((ddb)))

unsigned long sizeofddb(unsigned x, unsigned y)
    {
    switch(curddb)
        {
        case DDB_15BIT_PLANAR:
        case DDB_0815: return x*y*2+4;
        case DDB_8BIT_PLANAR: return x*y+4;
        case DDB_24BIT_RGB: return x*y*3+4;
        case DDB_24BIT_DWORD_RGB: return x*y*4+4;
        }
    _asm
        {
        mov ax, 0620h
        mov bx, x
        mov cx, y
        call curdrvcall
        mov x, ax
        mov y, dx
        }
    return y*256+x;
    }

int dib_create(int owner, unsigned width, unsigned height, unsigned bpp, int loadtype)
    {
    unsigned long needed=((width*bpp+7)/8)*height;
    void *mem=NULL;
    int swp=0;
    struct genericdib *adib;
    if(needed == 0) { debstr("ZERO"); return ERR_DIB_ZEROSIZE; }

//    loadtype = NEWDIB_LOAD_SWAP;    // TODO: Remove this line
//    loadtype = NEWDIB_LOAD_LOCALMEM;

    if(loadtype == NEWDIB_LOAD_LOCALMEM || loadtype == NEWDIB_TRY_LOCALMEM)
        {
        mem = (void *) mem_malloc(needed,owner);
        if(mem == NULL && loadtype == NEWDIB_TRY_LOCALMEM)
            swp = createtmp(owner);
        }
    else if(loadtype == NEWDIB_LOAD_SWAP || loadtype == NEWDIB_TRY_SWAP)
        {
        swp = createtmp(owner);
        if(swp == 0 && loadtype == NEWDIB_TRY_SWAP)
            mem = (void *) mem_malloc(needed,owner);
        }
    if(mem == NULL && swp == 0) { debstr("OUTOFMEM"); return ERR_OUTOFMEMORY; }
    if(dibs == NULL)
        {
        dibs = (struct genericdib *) mem_malloc(sizeof(struct genericdib),1);
        if(dibs == NULL)
            {
            if(mem) { mem_free((char *) mem); printf("mem_free dibcreate"); }
            if(swp) fsclose(swp);
            debstr("OUTOFMEM2");
            return ERR_OUTOFMEMORY;
            }
        adib = dibs;
        }
    else
        {
        adib = dibs;
        while(adib->next != NULL) adib = adib->next;
        adib->next = (struct genericdib *) mem_malloc(sizeof(struct genericdib),1);
        if(adib->next == NULL)
            {
            if(mem) { mem_free((char *) mem); printf("mem_free dibcreate2"); }
            if(swp) fsclose(swp);
            debstr("OUTOFMEM3");
            return ERR_OUTOFMEMORY;
            }
        adib = adib->next;
        }
    adib->next = NULL;
    adib->handle = nextdibhandle++;
    adib->width = width;
    adib->height = height;
    adib->bpp = bpp;
    adib->owner = owner;
    adib->dibdata = mem;
    adib->fhnd = swp;
    adib->size = needed;
    return(adib->handle);
    }

struct genericdib *finddib(int handle)
    {
    struct genericdib *adib;
    adib = dibs;
    while(adib)
        {
        if(adib->handle == handle) return adib;
        adib=adib->next;
        }
    return NULL;
    }

int dib_load(int owner, char *filename, int loadtype)
    {
    int fh=fsopenrel(filename,tasks[owner].curdir,owner);
    struct genericdib *dibdat;
    int dibh;
    char cbuf[4];
    struct { unsigned w,h,bpp,flags; } dibhdr;
    if(fh < 0) return fh;
    fsread(fh,4,cbuf);
    if(strcmp(cbuf,"DiB"))
        {
        fsclose(fh);
        return ERR_DIB_INVALID;
        }
    fsread(fh,sizeof(dibhdr),(char *) &dibhdr);
    dibh = dib_create(owner,dibhdr.w,dibhdr.h,dibhdr.bpp,loadtype);
    if(dibh < 0)
        {
        fsclose(fh);
        return dibh;
        }
    dibdat = finddib(dibh);
    if(dibdat->dibdata != 0)
        {
        fsread(fh,dibdat->size,dibdat->dibdata);
        fsclose(fh);
        return dibh;
        }
    else if(dibdat->fhnd != 0)
        {
        fsseek(dibdat->fhnd,0,SEEK_SET);
        copystuff(fh,dibdat->fhnd,owner);
        fsclose(fh);
        return dibh;
        }
    fsclose(fh);
    return ERR_GENERIC;
    }

dib_destroy(int handle)
    {
    struct genericdib *adib,*bdib;
    adib = dibs;
    if(dibs->handle == handle)
        {
        dibs = dibs->next;
        printf("memfreedibdestroy");
        mem_free((char *) adib);
        return 0;
        }
    while(adib->next)
        if(adib->next->handle == handle)
            {
            bdib = adib->next->next;
            mem_free((char *) adib->next->dibdata);
            mem_free((char *) adib->next);
            adib->next = bdib;
            return 0;
            }
    return ERR_INVALID_HANDLE;
    }

dib_to_ddb(int dibhandle, void *ddbbuf, int x1, int y1, int x2, int y2)
    {
    struct genericdib *adib=finddib(dibhandle);
    int width=x2-x1+1;
    int height=y2-y1+1;
    unsigned *ubuf;
    unsigned char *dibbuf, *cbuf, *buu;
    unsigned k;
    int i,j;
    int bsw=0;
   
    if(adib == NULL) return ERR_INVALID_HANDLE;
    if(width <= 0 || height <= 0) return ERR_INVALIDRECT;
//    debnum(x1);debnum(y1);debnum(x2);debnum(y2);
    if(adib->dibdata)
        switch(curddb | adib->bpp << 8)
            {
            case BPP8 << 8 | DDB_0815:
                {   // Convert 8-bit dib to 0815 ddb
                ubuf = ((unsigned *) ddbbuf) + 2;
                ubuf[-2] = width; ubuf[-1] = height;
                for(j=y1;j<=y2;j++)
                    {
                    dibbuf = ((unsigned char *) adib->dibdata) + (j*adib->width) + x1;
                    for(i=0;i<width;i++)
                        *(ubuf++) = *(dibbuf++);
                    }
                break;
                }
            case BPP8 << 8 | DDB_8BIT_PLANAR:
                {   // Convert 8-bit dib to 8bit planar ddb
                ubuf = ((unsigned *) ddbbuf);
                ubuf[0] = width; ubuf[1] = height;
                cbuf = ((unsigned char *) ubuf) + 4;
                for(j=y1;j<=y2;j++)
                    {
                    dibbuf = ((unsigned char *) adib->dibdata) + (j*adib->width) + x1;
                    for(i=0;i<width;i++)
                        *(cbuf++) = *(dibbuf++);
                    }
                break;
                }
            case BPP4 << 8 | DDB_8BIT_PLANAR:
                {   // Convert 4-bit planar rowbyte-aligned dib to 8bit planar ddb
                ubuf = ((unsigned *) ddbbuf);
                ubuf[0] = width; ubuf[1] = height;
                cbuf = ((unsigned char *) ubuf) + 4;
                for(j=y1;j<=y2;j++)
                    {
                    dibbuf = ((unsigned char *) adib->dibdata) +
                        (j*((adib->width+1)/2)) + x1/2;
                    bsw = x1%2;
                    for(i=0;i<width;i++)
                        *(cbuf++) = ((bsw=1-bsw) != NULL) ? *(dibbuf) >> 4 : *(dibbuf++) & 0xF;
                    }
                break;
                }
            default: { /* debstr("Unkbpp/ddb"); */ return ERR_GENERIC; }
            }
    else if(adib->fhnd)
        switch(curddb | adib->bpp << 8)
            {
            case BPP8 << 8 | DDB_0815:
                {   // Convert 8-bit dib to 0815 ddb
                ubuf = ((unsigned *) ddbbuf) + 2;
                ubuf[-2] = width; ubuf[-1] = height;
                for(j=y1;j<=y2;j++)
                    {
                    fsseek(adib->fhnd,(j*adib->width) + x1,SEEK_SET);
                    k = fsread(adib->fhnd,width,(char *) ubuf);
                    for(i=width-1;i>=0;i++)
                        ubuf[i] = ((unsigned char *) ubuf)[i];
                    ubuf += k;
                    }
                break;
                }
            case BPP8 << 8 | DDB_8BIT_PLANAR:
                {   // Convert 8-bit dib to 8bit planar ddb
                ubuf = ((unsigned *) ddbbuf);
                ubuf[0] = width; ubuf[1] = height;
                cbuf = ((unsigned char *) ubuf) + 4;
                for(j=y1;j<=y2;j++)
                    {
                    fsseek(adib->fhnd,(j*adib->width) + x1,SEEK_SET);
                    cbuf += fsread(adib->fhnd,width,(char *) cbuf);
                    }
                break;
                }
            case BPP4 << 8 | DDB_8BIT_PLANAR:
                {   // Convert 4-bit planar rowbyte-aligned dib to 8bit planar ddb
                ubuf = ((unsigned *) ddbbuf);
                ubuf[0] = width; ubuf[1] = height;
                cbuf = ((unsigned char *) ubuf) + 4;
                dibbuf = (unsigned char *) mem_malloc((width+1)/2,0);
                for(j=y1;j<=y2;j++)
                    {
                    fsseek(adib->fhnd,((long) j*(((long) adib->width+1)/2)) + (long) x1/2,SEEK_SET);
                    fsread(adib->fhnd,(width+1)/2,(char*) dibbuf);
                    bsw = x1%2;
                    buu = dibbuf;
                    for(i=0;i<width;i++)
                        *(cbuf++) = ((bsw=1-bsw) != NULL) ? *(dibbuf) >> 4 : *(dibbuf++) & 0xF;
                    dibbuf = buu;
                    }
                mem_free((char *) dibbuf);
                break;
                }
            default: { /* debstr("Unkbpp/ddb"); */ return ERR_GENERIC; }
            }
    else
        return ERR_GENERIC;
    return 0;
    }

void drawddb(UINT x, UINT y, char *ddb)
    {
    UINT i=FP_SEG(ddb),j=FP_OFF(ddb);
    if(curddb == DDB_0815) set0815(x,y,(UINT *) ddb); else
        {
        mouse_begindraw();
        _asm
            {
            push ds
            mov ax, i
            mov es, ax
            mov ax, 0621h
            mov bx, x
            mov cx, y
            mov si, j
            call curdrvcall
            pop ds
            }
        mouse_enddraw();
        }
    }

void readddb(UINT x1, UINT y1, UINT x2, UINT y2, char *ddb)
    {
    UINT i=FP_SEG(ddb),j=FP_OFF(ddb);
    if(curddb == DDB_0815) get0815(x1,y1,x2,y2,(UINT *) ddb); else
        {
        mouse_drawbegin();
        ((UINT *) ddb)[0] = x2-x1+1;
        ((UINT *) ddb)[1] = y2-y1+1;
        _asm
            {
            push ds
            mov ax, i
            mov es, ax
            mov ax, 0622h
            mov bx, x1
            mov cx, y1
            mov dx, x2
            mov si, y2
            mov di, j
            call curdrvcall
            pop ds
            }
        }
    }

#define dib_geomerty dib_geometry
dib_geometry(int handle, UINT *w, UINT *h)
    {
    struct genericdib *adib = finddib(handle);
    if(adib == NULL) return ERR_INVALID_HANDLE;
    *w = adib->width;
    *h = adib->height;
    }

char *ddb_loadfromfile(int owner, char *filename, int islarge)
    {
    int hndl=dib_load(owner,filename,islarge ? NEWDIB_TRY_SWAP : NEWDIB_TRY_LOCALMEM);
    UINT i,j;
    int ii;
    char *ddb;
    if(hndl < 0) return NULL;
    dib_geometry(hndl,&i,&j);
    if((ddb = mem_malloc(sizeofddb(i,j),owner)) != NULL)
        if((ii = dib_to_ddb(hndl,ddb,0,0,i-1,j-1)) < 0)
            {
            mem_free(ddb);
            return NULL;
            }
    dib_destroy(hndl);
    if(ddb == NULL && !islarge)
        ddb = ddb_loadfromfile(owner,filename,1);
    return ddb;
    }

/*
<USELESS>
                    i = FP_SEG(suchptr);
                    j = FP_OFF(suchptr);
                    _asm
                        {
                        push es
                        mov ax, i
                        mov es, ax
                        mov ax, 0623h
                        mov bx, x
                        mov cx, y
                        mov si, j
                        inc si
                        mov dx, pxhigh
                        call curdrvcall
                        pop es
                        cmp ax, 0xDEAD
                        jnz drchok
                        }
</USELESS>
*/
