#define ERR_OK 0
#define ERR_INVALIDAPI -1
#define ERR_OUTOFDISKSPACE -2
#define ERR_NATIVEOS -3
#define ERR_FILENOTFOUND -4
#define ERR_NOTSUPBYFS -5
#define ERR_DIRNOTFOUND -6
#define ERR_INVALIDFS -7
#define ERR_TOOMANYTASKS -8
#define ERR_TOOMANYMOUNTEDFS -9
#define ERR_GENERALDISK -10
#define ERR_MOUNTPARAMINVALID -11
#define ERR_INVALIDDRIVER -12
#define ERR_CANTCREATEFILE -13
#define ERR_TOOMANYOPENFILES -14
#define ERR_READONLY -15
#define ERR_IOCTL_NOTADRIVER -16
#define ERR_IOCTL_INVALIDACTION -17
#define ERR_OUTOFDRIVERHANDLES -18
#define ERR_INVALIDREQUEST -19
#define ERR_KERNELTOOOLD -20
#define ERR_HARDWARENOTFOUND -21
#define ERR_ACCESSDENIED -22
#define ERR_BLOCKSIZEINVALID -23
#define ERR_DRIVERMESSAGEINVALID -24
#define ERR_TIMEOUT -25
#define ERR_DRIVENOTREADY -26
#define ERR_NOTHINGMOUNTEDTHERE -27
#define ERR_DEVICEBUSY -28
#define ERR_NOLFNSUP -29
#define ERR_FILEISOPEN -30
#define ERR_DRIVERCANNOTDEL -31
#define ERR_UNKNOWN -32
#define ERR_FORMATUNSUP -33
#define ERR_INVALIDEXE -34
#define ERR_READERR -35
#define ERR_DEVINITFAILED -36
#define ERR_INVALIDRESOLUTION -37
#define ERR_OUTOFWNDS -38
#define ERR_MSGQUEUEFULL -39
#define ERR_INVALIDPID -40
#define ERR_NOMSG -41
#define ERR_NOMOUSE -42
#define ERR_ROOTNOTMOUNT -43
#define ERR_INVALIDFONTID -44
#define ERR_FONTVERNOTSUP -45
#define ERR_FONTTABFULL -46
#define ERR_OUTOFMEMORY -47
#define ERR_INVALIDGUIELE -48
#define ERR_DIB_ZEROSIZE -49
#define ERR_DIB_INVALID -50
#define ERR_GENERIC -51
#define ERR_INVALID_HANDLE -52
#define ERR_INVALIDHANDLE ERR_INVALID_HANDLE        // I always forgot the _
#define ERR_INVALIDRECT -53
#define ERR_NOTIMPLEMENTED -54

char *mcode(int code)
    {
    char *a="Unknown or invalid error-code:      ";
    itoa(code,a+31,7);
    return a;
    }

#define errtostr err_english
char *err_english(int error)
    {
    switch(error)
        {
        case 0: return "No error";
        case -1: return "Invalid API-Call";
        case -2: return "Out of diskspace";
        case -3: return "Native os (DOS) error";
        case -4: return "File not found";
        case -5: return "Action not supported by the filesystem";
        case -6: return "Directory not found";
        case -7: return "Invalid filesystem";
        case -8: return "Too many running tasks";
        case -9: return "Too many mounted filesystems";
        case -10: return "General disk-error";
        case -11: return "Invalid mount-parameter(s)";
        case -12: return "Invalid devicedriver";
        case -13: return "Can't create the file";
        case -14: return "Too many open files";
        case -15: return "File/Filesystem is read-only";
        case -16: return "IOCTL failed: The handle does not point to a driver";
        case -17: return "IOCTL failed: Invalid action-code";
        case -18: return "Driver embedding failed: No more handles available";
        case -19: return "Invalid driver-request";
        case -20: return "You need a newer "OSNAME" kernel";
        case -21: return "The requested hardware could not be found";
        case -22: return "Access denied";
        case -23: return "Invalid blocksize. Try it with 512-Byte blocks";
        case -24: return "The driver didn't understand the command";
        case -25: return "Request timed out";
        case -26: return "Drive/Device not ready";
        case -27: return "There's nothing mounted at the given mountpoint";
        case -28: return "Device busy";
        case -29: return "The host-OS doesn't support the LFN-API. Try to run "OSNAME" in a windows-\ndosbox or mount the device as DOS-FS";
        case -30: return "The file is open";
        case -31: return "Drivers cannot be deleted";
        case -32: return "Unkown error";
        case -33: return "Unsupported file-format";
        case -34: return "No executable file";
        case -35: return "Error reading file/disk";
        case -36: return "Driver-Init failed";
        case -37: return "Resolution not supported";
        case -38: return "Out of window-handles";
        case -39: return "Message-Queue full";
        case -40: return "Invalid PID";
        case -41: return "No messages in the queue";
        case -42: return "No mouse";
        case -43: return "ROOT-FS not mounted";
        case -44: return "Invalid font-ID or font not loaded";
        case -45: return "Font-version not supported";
        case -46: return "Font-table full";
        case -47: return "Out of memory";
        case -48: return "Invalid GUI-Handle";
        case -49: return "Zero-size bitmap";
        case -50: return "Invliad DiB";
        case -51: return "Generic error";
        case -52: return "Invalid handle";
        case -53: return "Invalid rectangle defination";
        case -54: return "Function not (yet) implemented"; 
        default: return mcode(error);
        }
    }
