// Std.C-Library can't be used. Let's define our own functions

UINT ffopen(char *fn, char cancreate)
    {
    UINT s=FP_SEG(fn),o=FP_OFF(fn);
    _asm
        {
        push ds
        mov ax, s
        mov ds, ax
        mov ah, 3dh
        mov al, 42h     //0100 0010
        mov dx, o
        int 21h
        jnc ffopenok
        pop ds

        // Well, opening didn't work
        cmp cancreate, 0
        jz gehtnet

        // Maybe we can create the file?

        push ds
        mov ax, s
        mov ds, ax
        mov ah, 5bh
        xor cx,cx
        mov dx, o
        int 21h
        jnc ffopenok
        pop ds
        jmp gehtnet2

        ffopenok:
        pop ds
        }
    return;
    gehtnet:
    return ERR_FILENOTFOUND;
    gehtnet2:
    return ERR_NATIVEOS;
    }

UINT ffread(UINT hndl, UINT numread, void *buf)
    {
    UINT s=FP_SEG(buf), o=FP_OFF(buf);
    _asm
        {
        push ds
        mov ax, s
        mov ds, ax
        mov ah, 3fh
        mov bx, hndl
        mov cx, numread
        mov dx, o
        int 21h
        jc ffread_end
        pop ds
        }
    return;
    ffread_end:
    return 0;
    }

UINT ffwrite(UINT hndl, UINT numread, void *buf)
    {
    UINT s=FP_SEG(buf), o=FP_OFF(buf);
    _asm
        {
        push ds
        mov ax, s
        mov ds, ax
        mov ah, 40h
        mov bx, hndl
        mov cx, numread
        mov dx, o
        int 21h
        jc ffwrite_end
        pop ds
        }
    return;
    ffwrite_end:
    return 0;
    }

UINT ffclose(UINT hndl)
    {
    _asm
        {
        mov ah, 3eh
        mov bx, hndl
        int 21h
        }
    }

long ffseek(UINT hndl, long offset, UCHR origin)
    {
    UINT i=offset/65536;
    UINT j=offset%65536;
    _asm
        {
        mov ah, 42h
        mov al, origin
        mov bx, hndl
        mov cx, i
        mov dx, j
        int 21h
        jc ffseek_err
        }
    return;
    ffseek_err:
    return -1;
    }

#define fftell(hndl) (ffseek((hndl),0,SEEK_CUR))

long ffsize(UINT hndl)
    {
    long x=ffseek(hndl,0,SEEK_END);
    ffseek(hndl,0,SEEK_SET);
    return x;
    }
