CPU 286
ORG -3

    db '->'     ; Begin
    db 0        ; Flags
    jmp start

%macro putcon 1
    mov ax, 8
    mov bx, %1
    mov cl, [conhndl]
    xor ch, ch
    int 0F0h

;    mov ax, 0ABBDh
;    int 0F0h
%endmacro

%macro putdeb 1
    mov ax, 0ABBDh
    mov bx, %1
    int 0F0h
%endmacro

%macro sleep 1
;    mov ax, 0x21
;    mov bx, %1
;    int 0F0h

    mov ax, 0Ch
    int 0F0h
    add ax, %1
    mov bx, ax

%%waitabit:
    mov ax, 0Ch
    int 0F0h
    cmp ax, bx
    jb %%waitabit
%endmacro

getnum:
    mov dx, 48
    mov cx, [hndl]
    mov bx, buf
    mov ax, 7
    int 0F0h

    mov ax, 2
    int 0F0h
    ret

openerr:
    xor ah, ah
    push ax
    putcon noload

    pop cx
    mov ax, 0xB
    int 0F0h

    mov ax, 8
    mov cl, [cs:conhndl]
    xor ch, ch
    int 0F0h
    sleep 2000
    xor ax, ax
    int 0F0h

start:
    push cs
    pop ds

    putdeb osinitgo

    mov ax, 5
    mov bx, confile
    xor cx, cx
    int 0F0h
    mov [conhndl], al

;;;; Load devicedrivers
    putcon loaddrv

    mov ax, 5               ; Open driverfile
    mov bx, drvfile
    xor cx, cx
    int 0F0h
    cmp al, 80
    jnb openerr
    xor ah, ah
    mov [hndl], ax

    mov ax, 9               ; EOF
    mov cx, [hndl]
    int 0F0h
    cmp ax, 0
    jnz nonodrv
    jmp nodrv
    nonodrv:

driver_loop:
    mov ax, 7               ; Readstring
    mov bx, buf
    mov cx, [hndl]
    int 0F0h

    putcon loadbuf

    mov ax, 0xa             ; INSMOD
    mov bx, buf
    int 0F0h
    cmp ax, 0x8000
    jnb openerr

    mov ax, 9               ; EOF
    mov cx, [hndl]
    int 0F0h
    cmp ax, 0
    jnz driver_loop

    mov ax, 6               ; Close
    mov cx, [hndl]
    int 0F0h

;;;; Load standard-fonts
    putcon ldfont
    mov ax, 1005h
    mov bx, font0
    int 0F0h
    cmp ax, 0
    jnz openerr

    putcon ldfont2
    mov ax, 1005h
    mov bx, font1
    int 0F0h
    cmp ax, 1
    jnz openerr

;    putcon ldfont3
;    mov ax, 1005h
;    mov bx, font2
;    int 0F0h
;    cmp ax, 2
;    jnz openerr
    
;;;; Load autostart applications
    putcon loadstrt

    mov ax, 5               ; Open strtfile
    mov bx, strtfile
    xor cx, cx
    int 0F0h
    cmp al, 80
    jnb openerr
    xor ah, ah
    mov [hndl], ax

    mov ax, 9               ; EOF
    mov cx, [hndl]
    int 0F0h
    cmp ax, 0
    jnz nonostrt
    jmp nostrt

    putcon alldone
    nonostrt:

;    mov ax, 0ABBCh          ; Recalibrate display
;    int 0F0h

strt_loop:
    mov ax, 7               ; Readstring
    mov bx, buf
    mov cx, [hndl]
    int 0F0h

    putcon loadbuf

    mov ax, 1               ; Start program
    mov bx, buf
    mov dx, stdparam
    int 0F0h

    push ds
    mov cx, 500
strtmore:
;    push cx
;    int 0F1h    ; Get idle
;    pop cx
    dec cx
    jnz strtmore
    pop ds

    mov ax, 9               ; EOF
    mov cx, [hndl]
    int 0F0h
    cmp ax, 0
    jnz strt_loop

    mov ax, 6               ; Close
    mov cx, [hndl]
    int 0F0h

;;;; Load display-settings
    putcon loaddis

    mov ax, 5               ; Open displayfile
    mov bx, disfile
    xor cx, cx
    int 0F0h
    cmp al, 80
    jnb openerr
    xor ah, ah
    mov [hndl], ax

    mov ax, 9               ; EOF
    mov cx, [hndl]
    int 0F0h
    cmp ax, 0
    jnz nonodis
    jmp nodis
    nonodis:

    call getnum
    push ax
    call getnum
    push ax
    call getnum
    push ax

    pop ax
    mov dx, ax
    pop cx
    pop bx
    mov ax, 0x40
    int 0F0h

;;;; Look for a keyboard

    putcon findkeyb
    mov ax, 0xABBC
    int 0F0h

;;;; Look for a mouse


    putcon findmouse
    mov ax, 0xABBB
    int 0F0h

    mov ax, 01011h          ; Clear screen
    mov bx, 0FFh
    int 0F0h
    sleep 10
    mov ax, 01011h          ; Clear screen
    xor bx,bx
    int 0F0h

;;;; Load windowmanager

    putdeb loadwm

    mov ax, 1017h
    mov si, ulwm
    int 0F0h

    putdeb osinitend

    xor ax, ax
    int 0F0h

;;;;;;;;;;;;;;;;;;;; END ;;;;;;;;;;;;;;;;;;;

nodrv:
    putcon nodrvmsg
    xor ax, ax
    int 0F0h

nodis:
    putcon nodismsg
    xor ax, ax
    int 0F0h

nostrt:
    putcon nostrtmsg
    xor ax, ax
    int 0F0h

confile:    db '/dev/tty0',0
conhndl:    db 0
hndl:       dw 0
loaddrv:    db 'Loading devicedrivers from '
drvfile:    db '/init/drivers.cfg',0
loaddis:    db 'Loading display settings from '
disfile:    db '/init/display.cfg',0
loadstrt:   db 'Loading autostart-file '
strtfile:   db '/init/startup.cfg',0
noload:     db 'Error occoured:',0
nodrvmsg:   db 'Devicedriver-file is empty.',0
nodismsg:   db 'Display-Settings file is empty',0
nostrtmsg:  db 'Autostart file is empty',0
findmouse:  db 'Looking for a mouse',0
findkeyb:   db 'Looking for a keyboard',0
ldfont:     db 'Loading standard-fonts',13,10,'Loading font: '
font0:      db '/init/8x8.fnt',0
ldfont2:    db 'Loading font: '
font1:      db '/init/8x16.fnt',0
;ldfont3:    db 'Loading font: '
;font2:      db '/init/ilfont.fnt',0
stdparam:   db 'StartUp',0
loadbuf:    db 'Loading: '
osinitgo:   db 'OSINIT: Started',0
osinitend:  db 'OSINIT: Done!',0
loadwm:     db 'Attaching windowmanager to display: '
ulwm:       db '/dev/ulsopwm',0
buf:        db '                                                ',0
alldone:    db 10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10
            db 10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,0
